/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: Transport.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */
#ifndef OpenSOAP_Transport_H
#define OpenSOAP_Transport_H

#include <OpenSOAP/ByteArray.h>
#include <OpenSOAP/Envelope.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

    typedef struct tagOpenSOAPTransport OpenSOAPTransport;
    typedef OpenSOAPTransport    *OpenSOAPTransportPtr;

    int
    OPENSOAP_API
    OpenSOAPTransportCreate(OpenSOAPTransportPtr * /* [out] */ t);

    int
    OPENSOAP_API
    OpenSOAPTransportRelease(OpenSOAPTransportPtr /* [in, out] */ t);

    int
    OPENSOAP_API
    OpenSOAPTransportSend(OpenSOAPTransportPtr /* [in] */ t,
                          OpenSOAPEnvelopePtr /* [in] */ soap_env);

    int
    OPENSOAP_API
    OpenSOAPTransportReceive(OpenSOAPTransportPtr /* [in] */ t,
                             OpenSOAPEnvelopePtr * /* [in, out] */ soap_env);

    int
    OPENSOAP_API
    OpenSOAPTransportConnect(OpenSOAPTransportPtr /* [in] */ t);

    int
    OPENSOAP_API
    OpenSOAPTransportDisconnect(OpenSOAPTransportPtr /* [in] */ t);

    int
    OPENSOAP_API
    OpenSOAPTransportInvokeByteArray(OpenSOAPTransportPtr /* [in] */ t,
                                     OpenSOAPByteArrayPtr /* [in] */ request,
                                     OpenSOAPByteArrayPtr
                                     /* [out] */ response,
                                     int * /* [out] */ tp_status);
    
    int
    OPENSOAP_API
    OpenSOAPTransportInvoke(OpenSOAPTransportPtr /* [in] */ t,
                            OpenSOAPEnvelopePtr /* [in] */ request,
                            OpenSOAPEnvelopePtr * /* [in, out] */ response);
    
    int
    OPENSOAP_API
    OpenSOAPTransportSetSOAPAction(OpenSOAPTransportPtr /* [in, out] */ t,
                                   const char * /* [in] */ soap_action);

    int
    OPENSOAP_API
    OpenSOAPTransportSetURL(OpenSOAPTransportPtr /* [in, out] */ t,
                            const char * /* [in] */ url);

    int
    OPENSOAP_API
    OpenSOAPTransportSetHeader(OpenSOAPTransportPtr /* [in, out] */ t,
                               const char * /* [in] */ header_name,
                               const char * /* [in] */ header_value);

    int
    OPENSOAP_API
    OpenSOAPTransportSetCharset(OpenSOAPTransportPtr /* [out] */ t,
                                const char * /* [in] */ charset);

    int
    OPENSOAP_API
    OpenSOAPTransportSMTPSetHostname(OpenSOAPTransportPtr /* [in, out] */ s);

    int
    OPENSOAP_API
    OpenSOAPTransportSMTPSetFrom(OpenSOAPTransportPtr /* [in, out] */ t);

    int
    OPENSOAP_API
    OpenSOAPTransportSMTPSetTo(OpenSOAPTransportPtr /* [in, out] */ t);
    
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* OpenSOAP_Transport_H */
