/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: SrvDrv.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef SRV_DRV_H
#define SRV_DRV_H

#include <string>
#include <vector>

#if defined(WIN32)
#include <windows.h>
#else
#include <pthread.h>
#endif

namespace OpenSOAP {
  class ChannelDescriptor;
  class SSMLInfo;
  
  class SrvDrv {
  private:
#if defined(WIN32)
	HANDLE _mt;
	static int mtCount;
#else
    pthread_mutex_t _mt;
#endif
    SSMLInfo ssmlInfo;
    
    bool _isAsync;
    bool _itIsAsyncFwdFinalReceiver;
    ChannelDescriptor chnlDesc_;
    
    std::string soapMsgFromMsgdrv;
    std::string soapMsgFromService;
    
    std::string fileIDOfMsgFromMsgdrv;
    std::string fileIDOfMsgFromService;
    
    unsigned int downside_timeout, ttl;
    
    std::string localhostname;
    
    std::vector<std::string> localURLs;
  private:
    //----- [JœIy[Vs߂̃Xbh  -----//
    static
#if defined(WIN32)
	void
#else
	void* 
#endif
	    localSyncThrSocket (void* arg);
    static
#if defined(WIN32)
	void
#else
	void* 
#endif
	    localSyncThrStdio (void* arg);

    //----- [J̓Iy[Vs -----//
    bool
    execLocalSyncOperation();
    
    //----- 񓯊̏ꍇ̃X|Xs -----//
    bool asyncResponse();
    
    //----- 񓯊]̍ŏIT[o[̏ꍇ̃X|Xs -----//
    bool asyncFwdResponse();
  public:
    SrvDrv(const ChannelDescriptor& chnlDesc);
    ~SrvDrv();
    
    void run();
    void setAsyncFlag(bool isAsync);
  };
  
}

#endif /* SRV_DRV_H */
